#pragma once
#include "Global.h"
#pragma		warning (disable:4146)
using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace ObjDataEdit
{
	/// <summary> 
	/// Summary for ViewForm
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class ViewForm : public System::Windows::Forms::Form
	{
	public: 
		ViewForm(void)
		{
			InitializeComponent();
			_IsNeedUpdate = true;
//            _IsValueChange = true;
            _IsMainChange = true;            
            _LMainModle  = ""; 
            _IscameraCycle = false;
            _ComboBoxEQList = new ArrayList();
			_ComboBoxEQList_Image = new ArrayList();
            _LabelEQList = new ArrayList();
            _PosIDMap   = new int[10];

			sqlConnection1->ConnectionString = Global::GetDBSource();
            sqlConnection1->Open();    
            _LObjImageID = 0;
		}
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
    private: System::Windows::Forms::Timer *  timer1;
    private: System::Windows::Forms::Panel *  PanelScreen;
    private: System::Data::SqlClient::SqlConnection *  sqlConnection1;
    private: System::Data::SqlClient::SqlCommand *  sqlCommand1;
    private: System::Windows::Forms::Panel *  panel1;
    private: System::Windows::Forms::Panel *  PanelViewControl;
    private: System::Windows::Forms::ComboBox *  CB_MotionList;
    private: System::Windows::Forms::Label *  label5;
    private: System::Windows::Forms::ComboBox *  CB_Face;
    private: System::Windows::Forms::ComboBox *  CB_Hair;
    private: System::Windows::Forms::Label *  label3;
    private: System::Windows::Forms::Label *  label4;
    private: System::Windows::Forms::ComboBox *  CB_TargetObj;
    private: System::Windows::Forms::ComboBox *  CB_MainObj;
    private: System::Windows::Forms::ComboBox *  CB_SecondHand;
    private: System::Windows::Forms::ComboBox *  CB_MainHand;
    private: System::Windows::Forms::ComboBox *  CB_Shoulder;
    private: System::Windows::Forms::ComboBox *  CB_Belt;
    private: System::Windows::Forms::ComboBox *  CB_Back;
    private: System::Windows::Forms::ComboBox *  CB_Pants;
    private: System::Windows::Forms::ComboBox *  CB_Clothes;
    private: System::Windows::Forms::ComboBox *  CB_Shoes;
    private: System::Windows::Forms::ComboBox *  CB_Gloves;
    private: System::Windows::Forms::ComboBox *  CB_Head;
    private: System::Windows::Forms::Label *  label2;
    private: System::Windows::Forms::Label *  label1;
    private: System::Windows::Forms::Label *  LB_SecondHand;
    private: System::Windows::Forms::Label *  LB_MainHand;
    private: System::Windows::Forms::Label *  LB_Shoulder;
    private: System::Windows::Forms::Label *  LB_Belt;
    private: System::Windows::Forms::Label *  LB_Back;
    private: System::Windows::Forms::Label *  LB_Pants;
    private: System::Windows::Forms::Label *  LB_Clothes;
    private: System::Windows::Forms::Label *  LB_Shoes;
    private: System::Windows::Forms::Label *  LB_Gloves;
    private: System::Windows::Forms::Label *  LB_Head;
    private: System::Windows::Forms::NumericUpDown *  NB_MainZ;
    private: System::Windows::Forms::NumericUpDown *  NB_MainX;
    private: System::Windows::Forms::Label *  label13;
    private: System::Windows::Forms::NumericUpDown *  NB_MainY;
    private: System::Windows::Forms::Label *  label15;
    private: System::Windows::Forms::NumericUpDown *  NB_TargetX;
    private: System::Windows::Forms::NumericUpDown *  NB_TargetZ;
    private: System::Windows::Forms::NumericUpDown *  NB_TargetY;
	private: System::Windows::Forms::CheckBox*  CB_ShowPoint;
	private: System::Windows::Forms::Label*  label6;
	private: System::Windows::Forms::ComboBox*  CB_MagicPoint;

	private: System::Windows::Forms::Label*  label7;
	protected: System::Windows::Forms::TextBox*  TB_MagicACT;
	private: 

	private: System::Windows::Forms::OpenFileDialog*  openFileDialog_Base;
	private: System::Windows::Forms::Button*  button1;
	private: System::Windows::Forms::Button*  button2;
	private: System::Windows::Forms::CheckBox*  CB_ShowWeapoin;

	private: System::Windows::Forms::CheckBox*  CB_ShowGrid;
	private: System::Windows::Forms::Button*  BT_unEQ;


	protected: 
	private: 

    private: System::ComponentModel::IContainer *  components;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (new System::ComponentModel::Container());
			this->timer1 = (new System::Windows::Forms::Timer(this->components));
			this->PanelScreen = (new System::Windows::Forms::Panel());
			this->sqlConnection1 = (new System::Data::SqlClient::SqlConnection());
			this->sqlCommand1 = (new System::Data::SqlClient::SqlCommand());
			this->panel1 = (new System::Windows::Forms::Panel());
			this->PanelViewControl = (new System::Windows::Forms::Panel());
			this->CB_ShowWeapoin = (new System::Windows::Forms::CheckBox());
			this->CB_ShowGrid = (new System::Windows::Forms::CheckBox());
			this->button2 = (new System::Windows::Forms::Button());
			this->button1 = (new System::Windows::Forms::Button());
			this->TB_MagicACT = (new System::Windows::Forms::TextBox());
			this->label7 = (new System::Windows::Forms::Label());
			this->label6 = (new System::Windows::Forms::Label());
			this->CB_MagicPoint = (new System::Windows::Forms::ComboBox());
			this->CB_ShowPoint = (new System::Windows::Forms::CheckBox());
			this->CB_MotionList = (new System::Windows::Forms::ComboBox());
			this->label5 = (new System::Windows::Forms::Label());
			this->CB_Face = (new System::Windows::Forms::ComboBox());
			this->CB_Hair = (new System::Windows::Forms::ComboBox());
			this->label3 = (new System::Windows::Forms::Label());
			this->label4 = (new System::Windows::Forms::Label());
			this->CB_TargetObj = (new System::Windows::Forms::ComboBox());
			this->CB_MainObj = (new System::Windows::Forms::ComboBox());
			this->CB_SecondHand = (new System::Windows::Forms::ComboBox());
			this->CB_MainHand = (new System::Windows::Forms::ComboBox());
			this->CB_Shoulder = (new System::Windows::Forms::ComboBox());
			this->CB_Belt = (new System::Windows::Forms::ComboBox());
			this->CB_Back = (new System::Windows::Forms::ComboBox());
			this->CB_Pants = (new System::Windows::Forms::ComboBox());
			this->CB_Clothes = (new System::Windows::Forms::ComboBox());
			this->CB_Shoes = (new System::Windows::Forms::ComboBox());
			this->CB_Gloves = (new System::Windows::Forms::ComboBox());
			this->CB_Head = (new System::Windows::Forms::ComboBox());
			this->label2 = (new System::Windows::Forms::Label());
			this->label1 = (new System::Windows::Forms::Label());
			this->LB_SecondHand = (new System::Windows::Forms::Label());
			this->LB_MainHand = (new System::Windows::Forms::Label());
			this->LB_Shoulder = (new System::Windows::Forms::Label());
			this->LB_Belt = (new System::Windows::Forms::Label());
			this->LB_Back = (new System::Windows::Forms::Label());
			this->LB_Pants = (new System::Windows::Forms::Label());
			this->LB_Clothes = (new System::Windows::Forms::Label());
			this->LB_Shoes = (new System::Windows::Forms::Label());
			this->LB_Gloves = (new System::Windows::Forms::Label());
			this->LB_Head = (new System::Windows::Forms::Label());
			this->NB_MainZ = (new System::Windows::Forms::NumericUpDown());
			this->NB_MainX = (new System::Windows::Forms::NumericUpDown());
			this->label13 = (new System::Windows::Forms::Label());
			this->NB_MainY = (new System::Windows::Forms::NumericUpDown());
			this->label15 = (new System::Windows::Forms::Label());
			this->NB_TargetX = (new System::Windows::Forms::NumericUpDown());
			this->NB_TargetZ = (new System::Windows::Forms::NumericUpDown());
			this->NB_TargetY = (new System::Windows::Forms::NumericUpDown());
			this->openFileDialog_Base = (new System::Windows::Forms::OpenFileDialog());
			this->BT_unEQ = (new System::Windows::Forms::Button());
			this->panel1->SuspendLayout();
			this->PanelViewControl->SuspendLayout();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_MainZ))->BeginInit();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_MainX))->BeginInit();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_MainY))->BeginInit();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_TargetX))->BeginInit();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_TargetZ))->BeginInit();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_TargetY))->BeginInit();
			this->SuspendLayout();
			// 
			// timer1
			// 
			this->timer1->Tick += new System::EventHandler(this, &ViewForm::OnTimeProc);
			// 
			// PanelScreen
			// 
			this->PanelScreen->Dock = System::Windows::Forms::DockStyle::Fill;
			this->PanelScreen->Location = System::Drawing::Point(0, 0);
			this->PanelScreen->Name = S"PanelScreen";
			this->PanelScreen->Size = System::Drawing::Size(560, 518);
			this->PanelScreen->TabIndex = 5;
			this->PanelScreen->MouseWheel += new System::Windows::Forms::MouseEventHandler(this, &ViewForm::OnMouseWheel);
			this->PanelScreen->MouseMove += new System::Windows::Forms::MouseEventHandler(this, &ViewForm::OnMouseMove);
			this->PanelScreen->MouseDown += new System::Windows::Forms::MouseEventHandler(this, &ViewForm::PanelScreen_MouseDown);
			this->PanelScreen->MouseUp += new System::Windows::Forms::MouseEventHandler(this, &ViewForm::PanelScreen_MouseUp);
			this->PanelScreen->SizeChanged += new System::EventHandler(this, &ViewForm::PanelScreen_SizeChanged);
			// 
			// sqlConnection1
			// 
			this->sqlConnection1->ConnectionString = S"workstation id=HSIANG;packet size=4096;user id=hsiangren;persist security info=Tr" 
				S"ue;initial catalog=ObjectData;password=2ddilxxl;data source=GS1";
			this->sqlConnection1->FireInfoMessageEventOnUserErrors = false;
			// 
			// sqlCommand1
			// 
			this->sqlCommand1->CommandText = S"INSERT INTO AccountDB (Account_id, Password) VALUES (\'ABC\', \'ABC\')";
			this->sqlCommand1->Connection = this->sqlConnection1;
			// 
			// panel1
			// 
			this->panel1->Controls->Add(this->PanelViewControl);
			this->panel1->Dock = System::Windows::Forms::DockStyle::Left;
			this->panel1->Location = System::Drawing::Point(0, 0);
			this->panel1->Name = S"panel1";
			this->panel1->Size = System::Drawing::Size(393, 518);
			this->panel1->TabIndex = 6;
			// 
			// PanelViewControl
			// 
			this->PanelViewControl->Controls->Add(this->CB_ShowWeapoin);
			this->PanelViewControl->Controls->Add(this->CB_ShowGrid);
			this->PanelViewControl->Controls->Add(this->BT_unEQ);
			this->PanelViewControl->Controls->Add(this->button2);
			this->PanelViewControl->Controls->Add(this->button1);
			this->PanelViewControl->Controls->Add(this->TB_MagicACT);
			this->PanelViewControl->Controls->Add(this->label7);
			this->PanelViewControl->Controls->Add(this->label6);
			this->PanelViewControl->Controls->Add(this->CB_MagicPoint);
			this->PanelViewControl->Controls->Add(this->CB_ShowPoint);
			this->PanelViewControl->Controls->Add(this->CB_MotionList);
			this->PanelViewControl->Controls->Add(this->label5);
			this->PanelViewControl->Controls->Add(this->CB_Face);
			this->PanelViewControl->Controls->Add(this->CB_Hair);
			this->PanelViewControl->Controls->Add(this->label3);
			this->PanelViewControl->Controls->Add(this->label4);
			this->PanelViewControl->Controls->Add(this->CB_TargetObj);
			this->PanelViewControl->Controls->Add(this->CB_MainObj);
			this->PanelViewControl->Controls->Add(this->CB_SecondHand);
			this->PanelViewControl->Controls->Add(this->CB_MainHand);
			this->PanelViewControl->Controls->Add(this->CB_Shoulder);
			this->PanelViewControl->Controls->Add(this->CB_Belt);
			this->PanelViewControl->Controls->Add(this->CB_Back);
			this->PanelViewControl->Controls->Add(this->CB_Pants);
			this->PanelViewControl->Controls->Add(this->CB_Clothes);
			this->PanelViewControl->Controls->Add(this->CB_Shoes);
			this->PanelViewControl->Controls->Add(this->CB_Gloves);
			this->PanelViewControl->Controls->Add(this->CB_Head);
			this->PanelViewControl->Controls->Add(this->label2);
			this->PanelViewControl->Controls->Add(this->label1);
			this->PanelViewControl->Controls->Add(this->LB_SecondHand);
			this->PanelViewControl->Controls->Add(this->LB_MainHand);
			this->PanelViewControl->Controls->Add(this->LB_Shoulder);
			this->PanelViewControl->Controls->Add(this->LB_Belt);
			this->PanelViewControl->Controls->Add(this->LB_Back);
			this->PanelViewControl->Controls->Add(this->LB_Pants);
			this->PanelViewControl->Controls->Add(this->LB_Clothes);
			this->PanelViewControl->Controls->Add(this->LB_Shoes);
			this->PanelViewControl->Controls->Add(this->LB_Gloves);
			this->PanelViewControl->Controls->Add(this->LB_Head);
			this->PanelViewControl->Controls->Add(this->NB_MainZ);
			this->PanelViewControl->Controls->Add(this->NB_MainX);
			this->PanelViewControl->Controls->Add(this->label13);
			this->PanelViewControl->Controls->Add(this->NB_MainY);
			this->PanelViewControl->Controls->Add(this->label15);
			this->PanelViewControl->Controls->Add(this->NB_TargetX);
			this->PanelViewControl->Controls->Add(this->NB_TargetZ);
			this->PanelViewControl->Controls->Add(this->NB_TargetY);
			this->PanelViewControl->Dock = System::Windows::Forms::DockStyle::Fill;
			this->PanelViewControl->Location = System::Drawing::Point(0, 0);
			this->PanelViewControl->Name = S"PanelViewControl";
			this->PanelViewControl->Size = System::Drawing::Size(393, 518);
			this->PanelViewControl->TabIndex = 0;
			// 
			// CB_ShowWeapoin
			// 
			this->CB_ShowWeapoin->AutoSize = true;
			this->CB_ShowWeapoin->Location = System::Drawing::Point(247, 427);
			this->CB_ShowWeapoin->Name = S"CB_ShowWeapoin";
			this->CB_ShowWeapoin->Size = System::Drawing::Size(96, 16);
			this->CB_ShowWeapoin->TabIndex = 128;
			this->CB_ShowWeapoin->Text = S"武器單獨顯示";
			this->CB_ShowWeapoin->UseVisualStyleBackColor = true;
			this->CB_ShowWeapoin->CheckedChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_ShowGrid
			// 
			this->CB_ShowGrid->AutoSize = true;
			this->CB_ShowGrid->Checked = true;
			this->CB_ShowGrid->CheckState = System::Windows::Forms::CheckState::Checked;
			this->CB_ShowGrid->Location = System::Drawing::Point(140, 427);
			this->CB_ShowGrid->Name = S"CB_ShowGrid";
			this->CB_ShowGrid->Size = System::Drawing::Size(72, 16);
			this->CB_ShowGrid->TabIndex = 127;
			this->CB_ShowGrid->Text = S"顯示格線";
			this->CB_ShowGrid->UseVisualStyleBackColor = true;
			this->CB_ShowGrid->CheckedChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// button2
			// 
			this->button2->Location = System::Drawing::Point(247, 399);
			this->button2->Name = S"button2";
			this->button2->Size = System::Drawing::Size(46, 23);
			this->button2->TabIndex = 126;
			this->button2->Text = S"Reset";
			this->button2->UseVisualStyleBackColor = true;
			this->button2->Click += new System::EventHandler(this, &ViewForm::CB_ResetInfo_Click);
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(167, 399);
			this->button1->Name = S"button1";
			this->button1->Size = System::Drawing::Size(67, 23);
			this->button1->TabIndex = 125;
			this->button1->Text = S"Play Again";
			this->button1->UseVisualStyleBackColor = true;
			this->button1->Click += new System::EventHandler(this, &ViewForm::CB_PlayMagicAgain);
			// 
			// TB_MagicACT
			// 
			this->TB_MagicACT->Location = System::Drawing::Point(48, 376);
			this->TB_MagicACT->Name = S"TB_MagicACT";
			this->TB_MagicACT->Size = System::Drawing::Size(323, 22);
			this->TB_MagicACT->TabIndex = 124;
			this->TB_MagicACT->Tag = S"";
			this->TB_MagicACT->DoubleClick += new System::EventHandler(this, &ViewForm::SearchPath_DClick);
			this->TB_MagicACT->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// label7
			// 
			this->label7->Location = System::Drawing::Point(12, 384);
			this->label7->Name = S"label7";
			this->label7->Size = System::Drawing::Size(32, 14);
			this->label7->TabIndex = 113;
			this->label7->Text = S"特效";
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->ForeColor = System::Drawing::SystemColors::ControlText;
			this->label6->Location = System::Drawing::Point(3, 399);
			this->label6->Name = S"label6";
			this->label6->Size = System::Drawing::Size(41, 12);
			this->label6->TabIndex = 111;
			this->label6->Text = S"參考點";
			// 
			// CB_MagicPoint
			// 
			System::Object* __mcTemp__1[] = new System::Object*[4];
			__mcTemp__1[0] = S"1";
			__mcTemp__1[1] = S"2";
			__mcTemp__1[2] = S"3";
			__mcTemp__1[3] = S"4";
			this->CB_MagicPoint->Items->AddRange(__mcTemp__1);
			this->CB_MagicPoint->Location = System::Drawing::Point(48, 401);
			this->CB_MagicPoint->Name = S"CB_MagicPoint";
			this->CB_MagicPoint->Size = System::Drawing::Size(116, 20);
			this->CB_MagicPoint->TabIndex = 112;
			this->CB_MagicPoint->Tag = S"TargetPoint";
			this->CB_MagicPoint->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_ShowPoint
			// 
			this->CB_ShowPoint->AutoSize = true;
			this->CB_ShowPoint->Location = System::Drawing::Point(32, 427);
			this->CB_ShowPoint->Name = S"CB_ShowPoint";
			this->CB_ShowPoint->Size = System::Drawing::Size(84, 16);
			this->CB_ShowPoint->TabIndex = 93;
			this->CB_ShowPoint->Text = S"顯示參考點";
			this->CB_ShowPoint->UseVisualStyleBackColor = true;
			this->CB_ShowPoint->CheckedChanged += new System::EventHandler(this, &ViewForm::CB_ShowPoint_CheckedChanged);
			// 
			// CB_MotionList
			// 
			this->CB_MotionList->Location = System::Drawing::Point(48, 8);
			this->CB_MotionList->Name = S"CB_MotionList";
			this->CB_MotionList->Size = System::Drawing::Size(323, 20);
			this->CB_MotionList->Sorted = true;
			this->CB_MotionList->TabIndex = 92;
			this->CB_MotionList->TextChanged += new System::EventHandler(this, &ViewForm::CB_MotionList_TextChanged);
			// 
			// label5
			// 
			this->label5->Location = System::Drawing::Point(16, 8);
			this->label5->Name = S"label5";
			this->label5->Size = System::Drawing::Size(32, 23);
			this->label5->TabIndex = 91;
			this->label5->Text = S"動作";
			// 
			// CB_Face
			// 
			this->CB_Face->Location = System::Drawing::Point(48, 56);
			this->CB_Face->Name = S"CB_Face";
			this->CB_Face->Size = System::Drawing::Size(323, 20);
			this->CB_Face->Sorted = true;
			this->CB_Face->TabIndex = 90;
			this->CB_Face->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_Hair
			// 
			this->CB_Hair->Location = System::Drawing::Point(48, 32);
			this->CB_Hair->Name = S"CB_Hair";
			this->CB_Hair->Size = System::Drawing::Size(323, 20);
			this->CB_Hair->Sorted = true;
			this->CB_Hair->TabIndex = 89;
			this->CB_Hair->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// label3
			// 
			this->label3->Location = System::Drawing::Point(16, 56);
			this->label3->Name = S"label3";
			this->label3->Size = System::Drawing::Size(32, 23);
			this->label3->TabIndex = 88;
			this->label3->Text = S"臉部";
			// 
			// label4
			// 
			this->label4->Location = System::Drawing::Point(16, 32);
			this->label4->Name = S"label4";
			this->label4->Size = System::Drawing::Size(32, 23);
			this->label4->TabIndex = 87;
			this->label4->Text = S"頭髮";
			// 
			// CB_TargetObj
			// 
			System::Object* __mcTemp__2[] = new System::Object*[2];
			__mcTemp__2[0] = S"model\\character\\pc\\human\\male\\act_hm_male.ros";
			__mcTemp__2[1] = S"model\\character\\pc\\human\\male\\act_hm_male.ros";
			this->CB_TargetObj->Items->AddRange(__mcTemp__2);
			this->CB_TargetObj->Location = System::Drawing::Point(48, 347);
			this->CB_TargetObj->Name = S"CB_TargetObj";
			this->CB_TargetObj->Size = System::Drawing::Size(323, 20);
			this->CB_TargetObj->Sorted = true;
			this->CB_TargetObj->TabIndex = 78;
			this->CB_TargetObj->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_MainObj
			// 
			System::Object* __mcTemp__3[] = new System::Object*[1];
			__mcTemp__3[0] = S"model\\character\\pc\\human\\male\\act_hm_male.ros";
			this->CB_MainObj->Items->AddRange(__mcTemp__3);
			this->CB_MainObj->Location = System::Drawing::Point(48, 324);
			this->CB_MainObj->Name = S"CB_MainObj";
			this->CB_MainObj->Size = System::Drawing::Size(323, 20);
			this->CB_MainObj->Sorted = true;
			this->CB_MainObj->TabIndex = 77;
			this->CB_MainObj->Text = S"model\\character\\pc\\human\\male\\act_hm_male.ros";
			this->CB_MainObj->TextChanged += new System::EventHandler(this, &ViewForm::CB_MainObj_TextChanged);
			// 
			// CB_SecondHand
			// 
			System::Object* __mcTemp__4[] = new System::Object*[1];
			__mcTemp__4[0] = S"model\\item\\blade\\rookie_sword.ros";
			this->CB_SecondHand->Items->AddRange(__mcTemp__4);
			this->CB_SecondHand->Location = System::Drawing::Point(48, 298);
			this->CB_SecondHand->Name = S"CB_SecondHand";
			this->CB_SecondHand->Size = System::Drawing::Size(323, 20);
			this->CB_SecondHand->Sorted = true;
			this->CB_SecondHand->TabIndex = 76;
			this->CB_SecondHand->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_MainHand
			// 
			System::Object* __mcTemp__5[] = new System::Object*[1];
			__mcTemp__5[0] = S"model\\item\\blade\\rookie_sword.ros";
			this->CB_MainHand->Items->AddRange(__mcTemp__5);
			this->CB_MainHand->Location = System::Drawing::Point(48, 274);
			this->CB_MainHand->Name = S"CB_MainHand";
			this->CB_MainHand->Size = System::Drawing::Size(323, 20);
			this->CB_MainHand->Sorted = true;
			this->CB_MainHand->TabIndex = 75;
			this->CB_MainHand->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_Shoulder
			// 
			this->CB_Shoulder->Location = System::Drawing::Point(48, 248);
			this->CB_Shoulder->Name = S"CB_Shoulder";
			this->CB_Shoulder->Size = System::Drawing::Size(323, 20);
			this->CB_Shoulder->Sorted = true;
			this->CB_Shoulder->TabIndex = 74;
			this->CB_Shoulder->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_Belt
			// 
			this->CB_Belt->Location = System::Drawing::Point(48, 224);
			this->CB_Belt->Name = S"CB_Belt";
			this->CB_Belt->Size = System::Drawing::Size(323, 20);
			this->CB_Belt->Sorted = true;
			this->CB_Belt->TabIndex = 73;
			this->CB_Belt->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_Back
			// 
			this->CB_Back->Location = System::Drawing::Point(48, 200);
			this->CB_Back->Name = S"CB_Back";
			this->CB_Back->Size = System::Drawing::Size(323, 20);
			this->CB_Back->Sorted = true;
			this->CB_Back->TabIndex = 72;
			this->CB_Back->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_Pants
			// 
			this->CB_Pants->Location = System::Drawing::Point(48, 176);
			this->CB_Pants->Name = S"CB_Pants";
			this->CB_Pants->Size = System::Drawing::Size(323, 20);
			this->CB_Pants->Sorted = true;
			this->CB_Pants->TabIndex = 71;
			this->CB_Pants->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_Clothes
			// 
			this->CB_Clothes->Location = System::Drawing::Point(48, 152);
			this->CB_Clothes->Name = S"CB_Clothes";
			this->CB_Clothes->Size = System::Drawing::Size(323, 20);
			this->CB_Clothes->Sorted = true;
			this->CB_Clothes->TabIndex = 70;
			this->CB_Clothes->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_Shoes
			// 
			this->CB_Shoes->Location = System::Drawing::Point(48, 128);
			this->CB_Shoes->Name = S"CB_Shoes";
			this->CB_Shoes->Size = System::Drawing::Size(323, 20);
			this->CB_Shoes->Sorted = true;
			this->CB_Shoes->TabIndex = 69;
			this->CB_Shoes->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_Gloves
			// 
			this->CB_Gloves->Location = System::Drawing::Point(48, 104);
			this->CB_Gloves->Name = S"CB_Gloves";
			this->CB_Gloves->Size = System::Drawing::Size(323, 20);
			this->CB_Gloves->Sorted = true;
			this->CB_Gloves->TabIndex = 68;
			this->CB_Gloves->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// CB_Head
			// 
			this->CB_Head->Location = System::Drawing::Point(48, 80);
			this->CB_Head->Name = S"CB_Head";
			this->CB_Head->Size = System::Drawing::Size(323, 20);
			this->CB_Head->Sorted = true;
			this->CB_Head->TabIndex = 67;
			this->CB_Head->TextChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// label2
			// 
			this->label2->Location = System::Drawing::Point(16, 350);
			this->label2->Name = S"label2";
			this->label2->Size = System::Drawing::Size(32, 23);
			this->label2->TabIndex = 66;
			this->label2->Text = S"目標";
			// 
			// label1
			// 
			this->label1->Location = System::Drawing::Point(16, 324);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(32, 23);
			this->label1->TabIndex = 65;
			this->label1->Text = S"主體";
			// 
			// LB_SecondHand
			// 
			this->LB_SecondHand->Location = System::Drawing::Point(16, 298);
			this->LB_SecondHand->Name = S"LB_SecondHand";
			this->LB_SecondHand->Size = System::Drawing::Size(32, 23);
			this->LB_SecondHand->TabIndex = 64;
			this->LB_SecondHand->Text = S"副手";
			// 
			// LB_MainHand
			// 
			this->LB_MainHand->Location = System::Drawing::Point(16, 274);
			this->LB_MainHand->Name = S"LB_MainHand";
			this->LB_MainHand->Size = System::Drawing::Size(32, 23);
			this->LB_MainHand->TabIndex = 63;
			this->LB_MainHand->Text = S"主手";
			// 
			// LB_Shoulder
			// 
			this->LB_Shoulder->Location = System::Drawing::Point(16, 248);
			this->LB_Shoulder->Name = S"LB_Shoulder";
			this->LB_Shoulder->Size = System::Drawing::Size(32, 23);
			this->LB_Shoulder->TabIndex = 62;
			this->LB_Shoulder->Text = S"肩甲";
			// 
			// LB_Belt
			// 
			this->LB_Belt->Location = System::Drawing::Point(16, 224);
			this->LB_Belt->Name = S"LB_Belt";
			this->LB_Belt->Size = System::Drawing::Size(32, 23);
			this->LB_Belt->TabIndex = 61;
			this->LB_Belt->Text = S"腰帶";
			// 
			// LB_Back
			// 
			this->LB_Back->Location = System::Drawing::Point(18, 199);
			this->LB_Back->Name = S"LB_Back";
			this->LB_Back->Size = System::Drawing::Size(24, 23);
			this->LB_Back->TabIndex = 60;
			this->LB_Back->Text = S"背";
			// 
			// LB_Pants
			// 
			this->LB_Pants->Location = System::Drawing::Point(16, 176);
			this->LB_Pants->Name = S"LB_Pants";
			this->LB_Pants->Size = System::Drawing::Size(32, 23);
			this->LB_Pants->TabIndex = 59;
			this->LB_Pants->Text = S"褲子";
			// 
			// LB_Clothes
			// 
			this->LB_Clothes->Location = System::Drawing::Point(16, 149);
			this->LB_Clothes->Name = S"LB_Clothes";
			this->LB_Clothes->Size = System::Drawing::Size(39, 23);
			this->LB_Clothes->TabIndex = 58;
			this->LB_Clothes->Text = S"衣服";
			// 
			// LB_Shoes
			// 
			this->LB_Shoes->Location = System::Drawing::Point(16, 128);
			this->LB_Shoes->Name = S"LB_Shoes";
			this->LB_Shoes->Size = System::Drawing::Size(32, 23);
			this->LB_Shoes->TabIndex = 57;
			this->LB_Shoes->Text = S"鞋子";
			// 
			// LB_Gloves
			// 
			this->LB_Gloves->Location = System::Drawing::Point(16, 104);
			this->LB_Gloves->Name = S"LB_Gloves";
			this->LB_Gloves->Size = System::Drawing::Size(32, 23);
			this->LB_Gloves->TabIndex = 56;
			this->LB_Gloves->Text = S"手套";
			// 
			// LB_Head
			// 
			this->LB_Head->Location = System::Drawing::Point(16, 80);
			this->LB_Head->Name = S"LB_Head";
			this->LB_Head->Size = System::Drawing::Size(16, 23);
			this->LB_Head->TabIndex = 55;
			this->LB_Head->Text = S"頭";
			// 
			// NB_MainZ
			// 
			this->NB_MainZ->Location = System::Drawing::Point(164, 458);
			System::Int32 __mcTemp__6[] = new System::Int32[4];
			__mcTemp__6[0] = 100;
			__mcTemp__6[1] = 0;
			__mcTemp__6[2] = 0;
			__mcTemp__6[3] = System::Int32::MinValue;
			this->NB_MainZ->Minimum = System::Decimal(__mcTemp__6);
			this->NB_MainZ->Name = S"NB_MainZ";
			this->NB_MainZ->Size = System::Drawing::Size(48, 22);
			this->NB_MainZ->TabIndex = 82;
			this->NB_MainZ->Visible = false;
			this->NB_MainZ->ValueChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// NB_MainX
			// 
			this->NB_MainX->Location = System::Drawing::Point(68, 458);
			System::Int32 __mcTemp__7[] = new System::Int32[4];
			__mcTemp__7[0] = 100;
			__mcTemp__7[1] = 0;
			__mcTemp__7[2] = 0;
			__mcTemp__7[3] = System::Int32::MinValue;
			this->NB_MainX->Minimum = System::Decimal(__mcTemp__7);
			this->NB_MainX->Name = S"NB_MainX";
			this->NB_MainX->Size = System::Drawing::Size(48, 22);
			this->NB_MainX->TabIndex = 80;
			System::Int32 __mcTemp__8[] = new System::Int32[4];
			__mcTemp__8[0] = 20;
			__mcTemp__8[1] = 0;
			__mcTemp__8[2] = 0;
			__mcTemp__8[3] = System::Int32::MinValue;
			this->NB_MainX->Value = System::Decimal(__mcTemp__8);
			this->NB_MainX->Visible = false;
			this->NB_MainX->ValueChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// label13
			// 
			this->label13->Location = System::Drawing::Point(12, 458);
			this->label13->Name = S"label13";
			this->label13->Size = System::Drawing::Size(56, 16);
			this->label13->TabIndex = 79;
			this->label13->Text = S"主體位置";
			this->label13->Visible = false;
			// 
			// NB_MainY
			// 
			this->NB_MainY->Location = System::Drawing::Point(116, 458);
			System::Int32 __mcTemp__9[] = new System::Int32[4];
			__mcTemp__9[0] = 100;
			__mcTemp__9[1] = 0;
			__mcTemp__9[2] = 0;
			__mcTemp__9[3] = System::Int32::MinValue;
			this->NB_MainY->Minimum = System::Decimal(__mcTemp__9);
			this->NB_MainY->Name = S"NB_MainY";
			this->NB_MainY->Size = System::Drawing::Size(48, 22);
			this->NB_MainY->TabIndex = 81;
			this->NB_MainY->Visible = false;
			this->NB_MainY->ValueChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// label15
			// 
			this->label15->Location = System::Drawing::Point(12, 482);
			this->label15->Name = S"label15";
			this->label15->Size = System::Drawing::Size(56, 16);
			this->label15->TabIndex = 83;
			this->label15->Text = S"目標位置";
			this->label15->Visible = false;
			// 
			// NB_TargetX
			// 
			this->NB_TargetX->Location = System::Drawing::Point(68, 482);
			System::Int32 __mcTemp__10[] = new System::Int32[4];
			__mcTemp__10[0] = 100;
			__mcTemp__10[1] = 0;
			__mcTemp__10[2] = 0;
			__mcTemp__10[3] = System::Int32::MinValue;
			this->NB_TargetX->Minimum = System::Decimal(__mcTemp__10);
			this->NB_TargetX->Name = S"NB_TargetX";
			this->NB_TargetX->Size = System::Drawing::Size(48, 22);
			this->NB_TargetX->TabIndex = 84;
			System::Int32 __mcTemp__11[] = new System::Int32[4];
			__mcTemp__11[0] = 20;
			__mcTemp__11[1] = 0;
			__mcTemp__11[2] = 0;
			__mcTemp__11[3] = 0;
			this->NB_TargetX->Value = System::Decimal(__mcTemp__11);
			this->NB_TargetX->Visible = false;
			this->NB_TargetX->ValueChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// NB_TargetZ
			// 
			this->NB_TargetZ->Location = System::Drawing::Point(164, 482);
			System::Int32 __mcTemp__12[] = new System::Int32[4];
			__mcTemp__12[0] = 100;
			__mcTemp__12[1] = 0;
			__mcTemp__12[2] = 0;
			__mcTemp__12[3] = System::Int32::MinValue;
			this->NB_TargetZ->Minimum = System::Decimal(__mcTemp__12);
			this->NB_TargetZ->Name = S"NB_TargetZ";
			this->NB_TargetZ->Size = System::Drawing::Size(48, 22);
			this->NB_TargetZ->TabIndex = 86;
			this->NB_TargetZ->Visible = false;
			this->NB_TargetZ->ValueChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// NB_TargetY
			// 
			this->NB_TargetY->Location = System::Drawing::Point(116, 482);
			System::Int32 __mcTemp__13[] = new System::Int32[4];
			__mcTemp__13[0] = 100;
			__mcTemp__13[1] = 0;
			__mcTemp__13[2] = 0;
			__mcTemp__13[3] = System::Int32::MinValue;
			this->NB_TargetY->Minimum = System::Decimal(__mcTemp__13);
			this->NB_TargetY->Name = S"NB_TargetY";
			this->NB_TargetY->Size = System::Drawing::Size(48, 22);
			this->NB_TargetY->TabIndex = 85;
			this->NB_TargetY->Visible = false;
			this->NB_TargetY->ValueChanged += new System::EventHandler(this, &ViewForm::CB_Belt_TextChanged);
			// 
			// BT_unEQ
			// 
			this->BT_unEQ->Location = System::Drawing::Point(299, 399);
			this->BT_unEQ->Name = S"BT_unEQ";
			this->BT_unEQ->Size = System::Drawing::Size(72, 23);
			this->BT_unEQ->TabIndex = 126;
			this->BT_unEQ->Text = S"顯示空裝";
			this->BT_unEQ->UseVisualStyleBackColor = true;
			this->BT_unEQ->Click += new System::EventHandler(this, &ViewForm::BT_unEQ_Click);
			// 
			// ViewForm
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 15);
			this->ClientSize = System::Drawing::Size(560, 518);
			this->Controls->Add(this->panel1);
			this->Controls->Add(this->PanelScreen);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::SizableToolWindow;
			this->Name = S"ViewForm";
			this->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
			this->Text = S"ViewForm";
			this->Load += new System::EventHandler(this, &ViewForm::ViewForm_Load);
			this->Closing += new System::ComponentModel::CancelEventHandler(this, &ViewForm::ViewForm_Closing);
			this->TextChanged += new System::EventHandler(this, &ViewForm::CB_MainObj_TextChanged);
			this->panel1->ResumeLayout(false);
			this->PanelViewControl->ResumeLayout(false);
			this->PanelViewControl->PerformLayout();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_MainZ))->EndInit();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_MainX))->EndInit();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_MainY))->EndInit();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_TargetX))->EndInit();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_TargetZ))->EndInit();
			(__try_cast<System::ComponentModel::ISupportInitialize*  >(this->NB_TargetY))->EndInit();
			this->ResumeLayout(false);

		}		

    public:

        static ViewForm*  g_ViewForm;
        static void Init( );

//        bool                _IsValueChange;
        bool                _IsMainChange;
        String*             _LMainModle;
        bool                _IscameraCycle;
        GameObjDbStruct     _GameObj;
        int                 _LMouseX;
        int                 _LMouseY;
        int                 _LObjImageID;				//最後顯示的圖形物件
        int*                _PosIDMap;
        ArrayList*          _ComboBoxEQList;
        ArrayList*          _ComboBoxEQList_Image;		//圖形的裝置ComboBox資料
        ArrayList*          _LabelEQList;
		int					_Clock;						//處理法術動態的時脈
		bool				_IsNeedUpdate;

        

        void    SetResourcePath();
        void    SetObjInfo( GameObjDbStruct* ImageObj );
        void    SetObjInfo( int ImageObjID );
        void    UpDateGraphic( );
        void    BaseUpDate( );
        void    SetComboBox( );
        void    SearchAllItem( char* Path );
		void	SetFilePath( );
		void	ResetMagicACT( );

		//更新魔法效果動態
		void	UpDateMagicAction( );

		//設定數值有改變
		void	SetValueChange(){ _IsNeedUpdate = true ; };

        void    SetDockPanel( Panel *  PanelView ,  Panel *  PanelControl )
        {
            PanelView->Controls->Add( PanelScreen );
            PanelControl->Controls->Add( PanelViewControl );
        }



    private: System::Void ViewForm_Load(System::Object *  sender, System::EventArgs *  e);
    private: System::Void OnTimeProc(System::Object *  sender, System::EventArgs *  e);
    private: System::Void PanelScreen_SizeChanged(System::Object *  sender, System::EventArgs *  e);
    private: System::Void ViewForm_Closing(System::Object *  sender, System::ComponentModel::CancelEventArgs *  e);
    private: System::Void OnMouseWheel(Object* Sender , System::Windows::Forms::MouseEventArgs* e);

    private: System::Void CB_Belt_TextChanged(System::Object *  sender, System::EventArgs *  e)
            {
                _IsNeedUpdate = true;
            }
    private: System::Void OnMouseMove(System::Object *  sender, System::Windows::Forms::MouseEventArgs* e);
    private: System::Void PanelScreen_MouseDown(System::Object *  sender, System::Windows::Forms::MouseEventArgs *  e)
            {
                _IscameraCycle = true;
                _LMouseX = e->X;
                _LMouseY = e->Y;
                PanelScreen->Focus(  );
            }

    private: System::Void PanelScreen_MouseUp(System::Object *  sender, System::Windows::Forms::MouseEventArgs *  e)
            {
                _IscameraCycle = false;
            }

    private: System::Void CB_MainObj_TextChanged(System::Object *  sender, System::EventArgs *  e)
            {                
                CB_Belt_TextChanged( sender , e );
                
            }

    private: System::Void CB_MotionList_TextChanged(System::Object *  sender, System::EventArgs *  e);
	private: System::Void CB_ShowPoint_CheckedChanged(System::Object*  sender, System::EventArgs*  e);
	private: System::Void SearchPath_DClick(System::Object*  sender, System::EventArgs*  e);
	private: System::Void CB_PlayMagicAgain(System::Object*  sender, System::EventArgs*  e);

	private: System::Void CB_ResetInfo_Click(System::Object*  sender, System::EventArgs*  e) 
			{
				SetResourcePath( );
			}
	private: System::Void BT_unEQ_Click(System::Object*  sender, System::EventArgs*  e) ;
};
}